/* ----------------------------------------------------------*/
/* STATA CONTROLS								 */
/* ----------------------------------------------------------*/

clear
clear matrix
set more off
set memory 850m, permanently


cd "C:\Users\Gareth\Documents\WikiTest\training.tsv_Pieces"


insheet using "training_1.tsv", clear
drop md5 revision_id
save t1.dta, replace


insheet using "training_2.tsv", clear
drop md5 revision_id
save t2.dta, replace


insheet using "training_3.tsv", clear
drop md5 revision_id
save t3.dta, replace


insheet using "training_4.tsv", clear
drop md5 revision_id
save t4.dta, replace


insheet using "training_5.tsv", clear
drop md5 revision_id
save t5.dta, replace


insheet using "training_6.tsv", clear
drop md5 revision_id
save t6.dta, replace


insheet using "training_7.tsv", clear
drop md5 revision_id
save t7.dta, replace


insheet using "training_8.tsv", clear
drop md5 revision_id
save t8.dta, replace


insheet using "training_9.tsv", clear
drop md5 revision_id
save t9.dta, replace


insheet using "training_10.tsv", clear
drop md5 revision_id
save t10.dta, replace


insheet using "training_11.tsv", clear
drop md5 revision_id
save t11.dta, replace


insheet using "training_12.tsv", clear
drop md5 revision_id
save t12.dta, replace


insheet using "training_13.tsv", clear
drop md5 revision_id
save t13.dta, replace


insheet using "training_14.tsv", clear
drop md5 revision_id
save t14.dta, replace


insheet using "training_15.tsv", clear
drop md5 revision_id
save t15.dta, replace


insheet using "training_16.tsv", clear
drop md5 revision_id
save t16.dta, replace


insheet using "training_17.tsv", clear
drop md5 revision_id
save t17.dta, replace


insheet using "training_18.tsv", clear
drop md5 revision_id
save t18.dta, replace


insheet using "training_19.tsv", clear
drop md5 revision_id
save t19.dta, replace


insheet using "training_20.tsv", clear
drop md5 revision_id
save t20.dta, replace


insheet using "training_21.tsv", clear
drop md5 revision_id
save t21.dta, replace


insheet using "training_22.tsv", clear
drop md5 revision_id
save t22.dta, replace


insheet using "training_23.tsv", clear
drop md5 revision_id
save t23.dta, replace


use t1.dta, clear
append using t2.dta
append using t3.dta
append using t4.dta
append using t5.dta
append using t6.dta
append using t7.dta
append using t8.dta
append using t9.dta
append using t10.dta
generate Time = clock(timestamp, "YMDhms")
format Time %tc
gen Day = dofc(Time)
format Day %td
gen DayNumber = day(Day)
gen Year = year(Day)
gen Month = month(Day)
drop timestamp Time Day
drop reverted_user_id reverted_revision_id
save t1-10.dta, replace

use t11.dta, clear
append using t12.dta
append using t13.dta
append using t14.dta
append using t15.dta
append using t16.dta
append using t17.dta
append using t18.dta
append using t19.dta
append using t20.dta
append using t21.dta
append using t22.dta
append using t23.dta
generate Time = clock(timestamp, "YMDhms")
drop timestamp
format Time %tc
gen Day = dofc(Time)
format Day %td
gen DayNumber = day(Day)
gen Year = year(Day)
gen Month = month(Day)
drop Time Day
drop reverted_user_id reverted_revision_id
save t11-23.dta, replace

use t1-10.dta, clear
append using t11-23.dta
save wiki.dta, replace




/* CALCULATE VARIABLES PER MONTH */


use wiki.dta, clear
keep if Year<=2006
collapse (count) article_id, by(user_id Year Month)
save count1.dta, replace

use wiki.dta, clear
keep if Year<=2006
collapse (sum) reverted, by(user_id Year Month)
save reverted1.dta, replace

use wiki.dta, clear
keep if Year<=2006
collapse (sum) delta, by(user_id Year Month)
save delta1.dta, replace

use wiki.dta, clear
keep if Year<=2006
collapse (sum) cur_size, by(user_id Year Month)
save cur_size1.dta, replace




use wiki.dta, clear
keep if Year>2006
collapse (count) article_id, by(user_id Year Month)
save count2.dta, replace

use wiki.dta, clear
keep if Year>2006
collapse (sum) reverted, by(user_id Year Month)
save reverted2.dta, replace

use wiki.dta, clear
keep if Year>2006
collapse (sum) delta, by(user_id Year Month)
save delta2.dta, replace

use wiki.dta, clear
keep if Year>2006
collapse (sum) cur_size, by(user_id Year Month)
save cur_size2.dta, replace


use count1.dta, clear
append using count2.dta
save count.dta, replace

use reverted1.dta, clear
append using reverted2.dta
save reverted.dta, replace

use delta1.dta, clear
append using delta2.dta
save delta.dta, replace

use cur_size1.dta, clear
append using cur_size2.dta
save cur_size.dta, replace


use count.dta, clear
merge 1:1 user_id Year Month using "reverted.dta"
drop _merge
merge 1:1 user_id Year Month using "delta.dta"
drop _merge
merge 1:1 user_id Year Month using "cur_size.dta"
drop _merge
merge m:1 Year Month using "totmonth.dta"
drop _merge
save wikisummary.dta, replace



/* CHANGE PER MONTH */



use wikisummary.dta, clear
rename article_id NumRevisionsLastMth
keep if MonthCycle==5
keep user_id NumRevisionsLastMth Tot5Month
save MonthlyNumRevisionsLastMth.dta, replace


use wikisummary.dta, clear
rename article_id NumRevisions
keep user_id TotMonth NumRevisions
reshape wide NumRevisions, i(user_id) j(TotMonth)
reshape long NumRevisions, i(user_id) j(TotMonth)
replace NumRevisions=0 if NumRevisions==.
tsset user_id TotMonth
gen MonthD1NumRevisionsLog = log((NumRevisions+1)/(L1.NumRevisions+1))
drop NumRevisions
merge m:1 TotMonth using "totmonth.dta"
drop _merge
drop if user_id==.
save MonthlyChangesStart.dta, replace




use MonthlyChangesStart.dta, clear
collapse (mean) MonthD1NumRevisionsLog, by(user_id Tot5Month)
rename  MonthD1NumRevisionsLog MeanChanges
save meanchanges.dta, replace


use MonthlyChangesStart.dta, clear
collapse (sd) MonthD1NumRevisionsLog, by(user_id Tot5Month)
rename  MonthD1NumRevisionsLog StDevChanges
save stdevchanges.dta, replace


use MonthlyChangesStart.dta, clear
keep if Tot5Month==88
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=88
save Monthly88.dta, replace

use MonthlyChangesStart.dta, clear
keep if Tot5Month==89
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=89
save Monthly89.dta, replace

use MonthlyChangesStart.dta, clear
keep if Tot5Month==90
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=90
save Monthly90.dta, replace

use MonthlyChangesStart.dta, clear
keep if Tot5Month==91
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=91
save Monthly91.dta, replace

use MonthlyChangesStart.dta, clear
keep if Tot5Month==92
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=92
save Monthly92.dta, replace

use MonthlyChangesStart.dta, clear
keep if Tot5Month==93
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=93
save Monthly93.dta, replace

use MonthlyChangesStart.dta, clear
keep if Tot5Month==94
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=94
save Monthly94.dta, replace

use MonthlyChangesStart.dta, clear
keep if Tot5Month==95
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=95
save Monthly95.dta, replace

use MonthlyChangesStart.dta, clear
keep if Tot5Month==96
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=96
save Monthly96.dta, replace

use MonthlyChangesStart.dta, clear
keep if Tot5Month==97
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=97
save Monthly97.dta, replace

use MonthlyChangesStart.dta, clear
keep if Tot5Month==98
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=98
save Monthly98.dta, replace

use MonthlyChangesStart.dta, clear
keep if Tot5Month==99
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=99
save Monthly99.dta, replace

use MonthlyChangesStart.dta, clear
keep if Tot5Month==100
rename MonthD1NumRevisionsLog MonthChange
keep MonthChange user_id MonthCycle
reshape wide MonthChange, i(user_id) j(MonthCycle)
gen Tot5Month=100
save Monthly100.dta, replace


use Monthly88.dta, clear
append using Monthly89.dta
append using Monthly90.dta
append using Monthly91.dta
append using Monthly92.dta
append using Monthly93.dta
append using Monthly94.dta
append using Monthly95.dta
append using Monthly96.dta
append using Monthly97.dta
append using Monthly98.dta
append using Monthly99.dta
append using Monthly100.dta
save MonthlyChanges.dta, replace






/* CALCULATE VARIABLES PER WEEK */


use wiki.dta, clear
keep if Year<=2006
gen Week=1 if DayNumber<7.5
replace Week=2 if DayNumber>7.5 & DayNumber<=15
replace Week=3 if DayNumber>15 & DayNumber<=22.5
replace Week=4 if DayNumber>22.5
keep user_id article_id Year Month Week
collapse (count) article_id, by(user_id Year Month Week)
save weekcount1.dta, replace 

use wiki.dta, clear
keep if Year>2006
gen Week=1 if DayNumber<7.5
replace Week=2 if DayNumber>7.5 & DayNumber<=15
replace Week=3 if DayNumber>15 & DayNumber<=22.5
replace Week=4 if DayNumber>22.5
keep user_id article_id Year Month Week
collapse (count) article_id, by(user_id Year Month Week)
save weekcount2.dta, replace 

use weekcount1.dta, clear
append using weekcount2.dta
rename article_id NumRevisionsWeek
save weekcount.dta, replace



use weekcount.dta, clear
merge m:1 Year Month Week using "totweek.dta"
drop _merge
save weekcounttotweek.dta, replace





use weekcounttotweek.dta, clear
merge m:1 TotWeek using "totweek.dta"
keep if WeekCycle==20
rename NumRevisionsWeek NumRevisionsLastWeek 
keep user_id NumRevisionsLastWeek Tot5Month
save WeeklyNumRevisionsLastWeek.dta, replace




use weekcounttotweek.dta, clear
keep user_id TotWeek NumRevisionsWeek
reshape wide NumRevisionsWeek, i(user_id) j(TotWeek)
reshape long NumRevisionsWeek, i(user_id) j(TotWeek)
replace NumRevisionsWeek=0 if NumRevisionsWeek==.
tsset user_id TotWeek
gen WeekD1NumRevisionsLog = log((NumRevisionsWeek+1)/(L1.NumRevisionsWeek+1))
save weekcounttotweek2.dta, replace
use weekcounttotweek2.dta, clear
merge m:1 TotWeek using "totweek.dta"
drop _merge
drop if Tot5Month==77
drop if Tot5Month==101
drop if user_id==.
save WeeklyChangesStart.dta, replace




use WeeklyChangesStart.dta, clear
keep if NumRevisionsWeek!=0
keep if NumRevisionsWeek!=.
collapse (count) NumRevisionsWeek, by(user_id Tot5Month)
rename NumRevisionsWeek NumWeeks
save NumWeeks.dta, replace



use WeeklyChangesStart.dta, clear
collapse (mean) WeekD1NumRevisionsLog, by(user_id Tot5Month)
rename  WeekD1NumRevisionsLog WeekMeanChanges
save weekmeanchanges.dta, replace


use WeeklyChangesStart.dta, clear
collapse (sd) WeekD1NumRevisionsLog, by(user_id Tot5Month)
rename  WeekD1NumRevisionsLog WeekStDevChanges
save weekstdevchanges.dta, replace



use WeeklyChangesStart.dta, clear
keep if Tot5Month==88
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=88
save Weekly88.dta, replace

use WeeklyChangesStart.dta, clear
keep if Tot5Month==89
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=89
save Weekly89.dta, replace

use WeeklyChangesStart.dta, clear
keep if Tot5Month==90
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=90
save Weekly90.dta, replace

use WeeklyChangesStart.dta, clear
keep if Tot5Month==91
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=91
save Weekly91.dta, replace

use WeeklyChangesStart.dta, clear
keep if Tot5Month==92
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=92
save Weekly92.dta, replace

use WeeklyChangesStart.dta, clear
keep if Tot5Month==93
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=93
save Weekly93.dta, replace

use WeeklyChangesStart.dta, clear
keep if Tot5Month==94
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=94
save Weekly94.dta, replace

use WeeklyChangesStart.dta, clear
keep if Tot5Month==95
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=95
save Weekly95.dta, replace

use WeeklyChangesStart.dta, clear
keep if Tot5Month==96
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=96
save Weekly96.dta, replace

use WeeklyChangesStart.dta, clear
keep if Tot5Month==97
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=97
save Weekly97.dta, replace

use WeeklyChangesStart.dta, clear
keep if Tot5Month==98
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=98
save Weekly98.dta, replace

use WeeklyChangesStart.dta, clear
keep if Tot5Month==99
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=99
save Weekly99.dta, replace

use WeeklyChangesStart.dta, clear
keep if Tot5Month==100
rename WeekD1NumRevisionsLog WeekChange
keep WeekChange user_id WeekCycle
reshape wide WeekChange, i(user_id) j(WeekCycle)
gen Tot5Month=100
save Weekly100.dta, replace


use Weekly88.dta, clear
append using Weekly89.dta
append using Weekly90.dta
append using Weekly91.dta
append using Weekly92.dta
append using Weekly93.dta
append using Weekly94.dta
append using Weekly95.dta
append using Weekly96.dta
append using Weekly97.dta
append using Weekly98.dta
append using Weekly99.dta
append using Weekly100.dta
save WeeklyChanges.dta, replace






/* CALCULATE VARIABLES PER DAY */

set more off

use wiki.dta, clear
keep if Year<=2006
rename DayNumber Day
keep user_id article_id Year Month Day
collapse (count) article_id, by(user_id Year Month Day)
save daycount1.dta, replace 

use wiki.dta, clear
keep if Year>2006
rename DayNumber Day
keep user_id article_id Year Month Day
collapse (count) article_id, by(user_id Year Month Day)
save daycount2.dta, replace 

use daycount1.dta, clear
append using daycount2.dta
rename article_id NumRevisionsDay
save daycount.dta, replace




use daycount.dta, clear
merge m:1 Year Month Day using "totday.dta"
drop _merge
save daycounttotday.dta, replace


use daycounttotday.dta, clear
keep if NumRevisionsDay!=0
keep if NumRevisionsDay!=.
collapse (count) NumRevisionsDay, by(user_id Tot5Month)
rename NumRevisionsDay NumDays
save NumDays.dta, replace


use daycounttotday.dta, clear
keep if NumRevisionsDay!=0
keep if NumRevisionsDay!=.
keep if DayCycle>120
collapse (count) NumRevisionsDay, by(user_id Tot5Month)
rename NumRevisionsDay NumDaysLastMth5
save NumDaysLastMth5.dta, replace







use daycounttotday.dta, clear
rename Day DayNumber
gen Week=1 if DayNumber<7.5
replace Week=2 if DayNumber>7.5 & DayNumber<=15
replace Week=3 if DayNumber>15 & DayNumber<=22.5
replace Week=4 if DayNumber>22.5
merge m:1 Year Month Week using "totweek.dta"
drop _merge
keep if NumRevisionsDay!=0
keep if NumRevisionsDay!=.
collapse (count) NumRevisionsDay, by(user_id Tot5Month WeekCycle)
rename NumRevisionsDay NumDaysPerWeek
save NumDaysPerWeek.dta, replace


use NumDaysPerWeek.dta, clear
keep if Tot5Month==88
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=88
save DaysPerWeek88.dta, replace

use NumDaysPerWeek.dta, clear
keep if Tot5Month==89
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=89
save DaysPerWeek89.dta, replace

use NumDaysPerWeek.dta, clear
keep if Tot5Month==90
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=90
save DaysPerWeek90.dta, replace

use NumDaysPerWeek.dta, clear
keep if Tot5Month==91
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=91
save DaysPerWeek91.dta, replace

use NumDaysPerWeek.dta, clear
keep if Tot5Month==92
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=92
save DaysPerWeek92.dta, replace

use NumDaysPerWeek.dta, clear
keep if Tot5Month==93
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=93
save DaysPerWeek93.dta, replace

use NumDaysPerWeek.dta, clear
keep if Tot5Month==94
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=94
save DaysPerWeek94.dta, replace

use NumDaysPerWeek.dta, clear
keep if Tot5Month==95
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=95
save DaysPerWeek95.dta, replace

use NumDaysPerWeek.dta, clear
keep if Tot5Month==96
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=96
save DaysPerWeek96.dta, replace

use NumDaysPerWeek.dta, clear
keep if Tot5Month==97
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=97
save DaysPerWeek97.dta, replace

use NumDaysPerWeek.dta, clear
keep if Tot5Month==98
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=98
save DaysPerWeek98.dta, replace

use NumDaysPerWeek.dta, clear
keep if Tot5Month==99
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=99
save DaysPerWeek99.dta, replace

use NumDaysPerWeek.dta, clear
keep if Tot5Month==100
keep NumDaysPerWeek user_id WeekCycle
reshape wide NumDaysPerWeek, i(user_id) j(WeekCycle)
gen Tot5Month=100
save DaysPerWeek100.dta, replace


use DaysPerWeek88.dta, clear
append using DaysPerWeek89.dta
append using DaysPerWeek90.dta
append using DaysPerWeek91.dta
append using DaysPerWeek92.dta
append using DaysPerWeek93.dta
append using DaysPerWeek94.dta
append using DaysPerWeek95.dta
append using DaysPerWeek96.dta
append using DaysPerWeek97.dta
append using DaysPerWeek98.dta
append using DaysPerWeek99.dta
append using DaysPerWeek100.dta
save DaysPerWeekChanges.dta, replace


/* CREATE BALANCED PANEL AND MERGE CALCULATED DATA TO IT */

use wikisummary.dta, clear
keep user_id TotMonth reverted
reshape wide reverted, i(user_id) j(TotMonth)
reshape long reverted, i(user_id) j(TotMonth)
save wikiwithzeros.dta, replace



use wikiwithzeros.dta, clear
drop reverted
merge 1:1 user_id TotMonth using wikisummary.dta
drop _merge Tot5Month Year Month MonthCycle
mvencode _all, mv(.=0) override
save wikiall.dta, replace 


/* ADD DATA ON TOT5MONTH */

use wikiall.dta, clear
merge m:1 TotMonth using totmonth.dta
drop _merge

tsset user_id TotMonth
rename article_id NumRevisions
save wikifinal.dta, replace




/* ADD TOT5MONTH==101 AND CALCULATE PER TOT5MONTH */

use wikifinal.dta, clear
append using forecast.dta
collapse (sum) NumRevisions, by(user_id Tot5Month)
tsset user_id Tot5Month
save wikifinal5mthNumRev.dta, replace

use wikifinal.dta, clear
append using forecast.dta
collapse (sum) delta, by(user_id Tot5Month)
tsset user_id Tot5Month
save wikifinal5mthDelta.dta, replace

use wikifinal.dta, clear
append using forecast.dta
collapse (sum) reverted, by(user_id Tot5Month)
tsset user_id Tot5Month
save wikifinal5mthRevert.dta, replace




/* CALCULATE UNIQUE ARTICLES PER TOT5MONTH */

use wiki.dta, clear
keep user_id article_id Year Month
merge m:1 Year Month using "totmonth.dta"
drop _merge
save wikiuniquearticles.dta, replace

use wikiuniquearticles.dta, clear
keep if Tot5Month<92
egen byte YearUniqueArticles = tag(user_id article_id Tot5Month)
collapse (sum) YearUniqueArticles, by(user_id Tot5Month)
save unique1.dta, replace

use wikiuniquearticles.dta, clear
keep if Tot5Month>=92
egen byte YearUniqueArticles = tag(user_id article_id Tot5Month)
collapse (sum) YearUniqueArticles, by(user_id Tot5Month)
save unique2.dta, replace

use unique1.dta, clear
append using unique2.dta
save unique5mth.dta, replace



/* MERGE PER TOT5MONTH */

use wikifinal5mthNumRev.dta, clear
merge 1:1 user_id Tot5Month using "wikifinal5mthDelta.dta", nogenerate
merge 1:1 user_id Tot5Month using "wikifinal5mthRevert.dta", nogenerate
merge 1:1 user_id Tot5Month using "unique5mth.dta", nogenerate
replace YearUniqueArticles=0 if YearUniqueArticles==.
save wikifinal.dta, replace






/* MERGE MONTHLY TO TOT5MONTH */

use wikifinal.dta, clear
merge 1:1 user_id Tot5Month using "MonthlyChanges.dta"
drop _merge
merge 1:1 user_id Tot5Month using "MonthlyNumRevisionsLastMth.dta"
drop _merge
merge 1:1 user_id Tot5Month using "WeeklyNumRevisionsLastWeek.dta"
drop _merge
merge 1:1 user_id Tot5Month using "stdevchanges.dta"
drop _merge
merge 1:1 user_id Tot5Month using "meanchanges.dta"
drop _merge
merge 1:1 user_id Tot5Month using "WeeklyChanges.dta"
drop _merge
merge 1:1 user_id Tot5Month using "NumWeeks.dta"
drop _merge
merge 1:1 user_id Tot5Month using "NumDays.dta"
drop _merge
merge 1:1 user_id Tot5Month using "NumDaysLastMth5.dta"
drop _merge
merge 1:1 user_id Tot5Month using "weekstdevchanges.dta"
drop _merge
merge 1:1 user_id Tot5Month using "weekmeanchanges.dta"
drop _merge
mvencode NumRevisionsLastMth, mv(.=0) override
mvencode NumRevisionsLastWeek, mv(.=0) override
mvencode NumWeeks, mv(.=0) override
mvencode NumDays, mv(.=0) override
mvencode NumDaysLastMth*, mv(.=0) override
save wikifinalmonth.dta, replace










/* REGRESSIONS */

set more off


use wikifinalmonth.dta, clear


gen L1NumRevisions=L1.NumRevisions
gen L2NumRevisions=L2.NumRevisions
gen L3NumRevisions=L3.NumRevisions
gen L4NumRevisions=L4.NumRevisions
gen L5NumRevisions=L5.NumRevisions
gen L6NumRevisions=L6.NumRevisions

gen L1NumRevisionsSq=L1.NumRevisions*L1.NumRevisions

gen NumRevisionsLog = log(NumRevisions+1)
gen L1NumRevisionsLog=L1.NumRevisionsLog
gen L2NumRevisionsLog=L2.NumRevisionsLog
gen L3NumRevisionsLog=L3.NumRevisionsLog
gen L4NumRevisionsLog=L4.NumRevisionsLog
gen L5NumRevisionsLog=L5.NumRevisionsLog
gen L6NumRevisionsLog=L6.NumRevisionsLog

gen L1WeekChange1 = L1.WeekChange1
gen L1WeekChange2 = L1.WeekChange2
gen L1WeekChange3 = L1.WeekChange3
gen L1WeekChange4 = L1.WeekChange4
gen L1WeekChange5 = L1.WeekChange5
gen L1WeekChange6 = L1.WeekChange6
gen L1WeekChange7 = L1.WeekChange7
gen L1WeekChange8 = L1.WeekChange8
gen L1WeekChange9 = L1.WeekChange9
gen L1WeekChange10 = L1.WeekChange10
gen L1WeekChange11 = L1.WeekChange11
gen L1WeekChange12 = L1.WeekChange12
gen L1WeekChange13 = L1.WeekChange13
gen L1WeekChange14 = L1.WeekChange14
gen L1WeekChange15 = L1.WeekChange15
gen L1WeekChange16 = L1.WeekChange16
gen L1WeekChange17 = L1.WeekChange17
gen L1WeekChange18 = L1.WeekChange18
gen L1WeekChange19 = L1.WeekChange19
gen L1WeekChange20 = L1.WeekChange20

gen L2WeekChange1 = L2.WeekChange1
gen L2WeekChange2 = L2.WeekChange2
gen L2WeekChange3 = L2.WeekChange3
gen L2WeekChange4 = L2.WeekChange4
gen L2WeekChange5 = L2.WeekChange5
gen L2WeekChange6 = L2.WeekChange6
gen L2WeekChange7 = L2.WeekChange7
gen L2WeekChange8 = L2.WeekChange8
gen L2WeekChange9 = L2.WeekChange9
gen L2WeekChange10 = L2.WeekChange10
gen L2WeekChange11 = L2.WeekChange11
gen L2WeekChange12 = L2.WeekChange12
gen L2WeekChange13 = L2.WeekChange13
gen L2WeekChange14 = L2.WeekChange14
gen L2WeekChange15 = L2.WeekChange15
gen L2WeekChange16 = L2.WeekChange16
gen L2WeekChange17 = L2.WeekChange17
gen L2WeekChange18 = L2.WeekChange18
gen L2WeekChange19 = L2.WeekChange19
gen L2WeekChange20 = L2.WeekChange20

gen L1MonthChange1 = L1.MonthChange1
gen L1MonthChange2 = L1.MonthChange2
gen L1MonthChange3 = L1.MonthChange3
gen L1MonthChange4 = L1.MonthChange4
gen L1MonthChange5 = L1.MonthChange5

gen L2MonthChange1 = L2.MonthChange1
gen L2MonthChange2 = L2.MonthChange2
gen L2MonthChange3 = L2.MonthChange3
gen L2MonthChange4 = L2.MonthChange4
gen L2MonthChange5 = L2.MonthChange5

gen L3MonthChange1 = L3.MonthChange1
gen L3MonthChange2 = L3.MonthChange2
gen L3MonthChange3 = L3.MonthChange3
gen L3MonthChange4 = L3.MonthChange4
gen L3MonthChange5 = L3.MonthChange5

gen L4MonthChange1 = L4.MonthChange1
gen L4MonthChange2 = L4.MonthChange2
gen L4MonthChange3 = L4.MonthChange3
gen L4MonthChange4 = L4.MonthChange4
gen L4MonthChange5 = L4.MonthChange5

gen L5MonthChange1 = L5.MonthChange1
gen L5MonthChange2 = L5.MonthChange2
gen L5MonthChange3 = L5.MonthChange3
gen L5MonthChange4 = L5.MonthChange4
gen L5MonthChange5 = L5.MonthChange5

gen L6MonthChange1 = L6.MonthChange1
gen L6MonthChange2 = L6.MonthChange2
gen L6MonthChange3 = L6.MonthChange3
gen L6MonthChange4 = L6.MonthChange4
gen L6MonthChange5 = L6.MonthChange5


gen L1WeekStDevChanges = L1.WeekStDevChanges
gen L2WeekStDevChanges = L2.WeekStDevChanges
gen L3WeekStDevChanges = L3.WeekStDevChanges
gen L4WeekStDevChanges = L4.WeekStDevChanges
gen L5WeekStDevChanges = L5.WeekStDevChanges
gen L6WeekStDevChanges = L6.WeekStDevChanges

gen L1WeekMeanChanges = L1.WeekMeanChanges
gen L2WeekMeanChanges = L2.WeekMeanChanges
gen L3WeekMeanChanges = L3.WeekMeanChanges
gen L4WeekMeanChanges = L4.WeekMeanChanges

gen L1StDevChanges = L1.StDevChanges
gen L2StDevChanges = L2.StDevChanges
gen L3StDevChanges = L3.StDevChanges
gen L4StDevChanges = L4.StDevChanges
gen L5StDevChanges = L5.StDevChanges
gen L6StDevChanges = L6.StDevChanges

gen L1MeanChanges = L1.MeanChanges
gen L2MeanChanges = L2.MeanChanges
gen L3MeanChanges = L3.MeanChanges
gen L4MeanChanges = L4.MeanChanges

gen NumWeeksLog=log(NumWeeks+1)
gen L1NumWeeks=L1.NumWeeksLog
gen L2NumWeeks=L2.NumWeeksLog
gen L3NumWeeks=L3.NumWeeksLog
gen L4NumWeeks=L4.NumWeeksLog
gen L5NumWeeks=L5.NumWeeksLog
gen L6NumWeeks=L6.NumWeeksLog

gen NumDaysLog=log(NumDays+1)
gen L1NumDays=L1.NumDaysLog
gen L2NumDays=L2.NumDaysLog
gen L3NumDays=L3.NumDaysLog
gen L4NumDays=L4.NumDaysLog
gen L5NumDays=L5.NumDaysLog
gen L6NumDays=L6.NumDaysLog


gen NumDaysLastMth5Log=log(NumDaysLastMth5+1)
gen L1NumDaysLastMth5=L1.NumDaysLastMth5Log
gen L2NumDaysLastMth5=L2.NumDaysLastMth5Log
gen L3NumDaysLastMth5=L3.NumDaysLastMth5Log
gen L4NumDaysLastMth5=L4.NumDaysLastMth5Log
gen L5NumDaysLastMth5=L5.NumDaysLastMth5Log
gen L6NumDaysLastMth5=L6.NumDaysLastMth5Log


drop WeekChange*
drop MonthChange*
drop NumDays*



gen L1delta=L1.delta
gen L1reverted=L1.reverted
gen L1YearUniqueArticles=L1.YearUniqueArticles

gen L1deltaPosDummy=1 if L1.delta>0
replace L1deltaPosDummy=0 if L1deltaPosDummy==.

gen L1revertedPct=L1.reverted/L1.NumRevisions
replace L1revertedPct=0 if L1revertedPct==.

gen L1YearUniqueArticlesPct=L1.YearUniqueArticles/L1.NumRevisions
replace L1YearUniqueArticlesPct=0 if L1YearUniqueArticlesPct==.


gen D1YearUniqueArticlesLog = log((YearUniqueArticles+1)/(L1.YearUniqueArticles+1))
gen D2YearUniqueArticlesLog = log((L1.YearUniqueArticles+1)/(L2.YearUniqueArticles+1))
gen D3YearUniqueArticlesLog = log((L2.YearUniqueArticles+1)/(L3.YearUniqueArticles+1))
gen D4YearUniqueArticlesLog = log((L3.YearUniqueArticles+1)/(L4.YearUniqueArticles+1))
gen D5YearUniqueArticlesLog = log((L4.YearUniqueArticles+1)/(L5.YearUniqueArticles+1))
gen D6YearUniqueArticlesLog = log((L5.YearUniqueArticles+1)/(L6.YearUniqueArticles+1))
gen D7YearUniqueArticlesLog = log((L6.YearUniqueArticles+1)/(L7.YearUniqueArticles+1))


tsset user_id Tot5Month


gen TotalPubs = 0 if Tot5Month==79
replace TotalPubs = NumRevisions + L1.TotalPubs if TotalPubs==.
gen L1TotalPubs = L1.TotalPubs

gen Age = 1 if TotalPubs!=0 & L1.TotalPubs==0
replace Age = L1.Age + 1 if Age==.
gen L1Age = L1.Age
gen L1Age2= L1Age*L1Age
gen AgeLog = log(Age)
gen L1lnAge = L1.AgeLog


gen AvePubs = TotalPubs/Age
gen AvePubsLog = log(AvePubs)
gen L1AvePubs = L1.AvePubs
gen L1lnAvePubs = L1.AvePubsLog

gen D1NumRevisionsLog = log((NumRevisions+1)/(L1.NumRevisions+1))
gen D2NumRevisionsLog = log((L1.NumRevisions+1)/(L2.NumRevisions+1))
gen D3NumRevisionsLog = log((L2.NumRevisions+1)/(L3.NumRevisions+1))
gen D4NumRevisionsLog = log((L3.NumRevisions+1)/(L4.NumRevisions+1))
gen D5NumRevisionsLog = log((L4.NumRevisions+1)/(L5.NumRevisions+1))
gen D6NumRevisionsLog = log((L5.NumRevisions+1)/(L6.NumRevisions+1))
gen D7NumRevisionsLog = log((L6.NumRevisions+1)/(L7.NumRevisions+1))


gen New = 1 if NumRevisions!=0 & L1.TotalPubs==0
replace New = 0 if New==.
tabstat New, statistics( sum ) by(Tot5Month) columns(variables)

gen L2revertedPct = L1.L1revertedPct
gen L2YearUniqueArticlesPct = L1.L1YearUniqueArticlesPct
gen L3revertedPct = L2.L1revertedPct
gen L3YearUniqueArticlesPct = L2.L1YearUniqueArticlesPct
gen L4revertedPct = L3.L1revertedPct
gen L4YearUniqueArticlesPct = L3.L1YearUniqueArticlesPct


cap drop xbChange1 xbPredict1
cap drop xbChange2 xbPredict2
cap drop xbChange3 xbPredict3
cap drop xbChange4 xbPredict4
cap drop xbChange5 xbPredict5
cap drop xbChange6 xbPredict6
cap drop z x



/*  Zero for ONE periods */

regress D1NumRevisionsLog L2NumWeeks L2NumDays L2NumDaysLastMth5 L2NumRevisions L2WeekChange1 L2WeekChange2 L2WeekChange3 L2WeekChange4 L2WeekChange5 L2WeekChange6 L2WeekChange7 L2WeekChange8 L2WeekChange9 L2WeekChange10 L2WeekChange11 L2WeekChange12 L2WeekChange13 L2WeekChange14 L2WeekChange15 L2WeekChange16 L2WeekChange17 L2WeekChange18 L2WeekChange19 L2WeekChange20 L2MonthChange1 L2MonthChange2 L2MonthChange3 L2MonthChange4 L2MonthChange5 L2StDevChanges L2NumRevisionsLog L1lnAge L1lnAvePubs if L1NumRevisions==0 & L2NumRevisions!=0 & L1.TotalPubs!=0 & Tot5Month>=93 & Tot5Month<=99
predict xbChange1, xb
gen xbPredict1 = exp(xbChange1)*(L1NumRevisions+1) - 1 if L1NumRevisions==0 & L2NumRevisions!=0 & L1.TotalPubs!=0


/*  Zero for TWO periods */

regress D1NumRevisionsLog L3NumWeeks L3NumDays L3NumDaysLastMth5 L3NumRevisions L3MonthChange1 L3MonthChange2 L3MonthChange3 L3MonthChange4 L3MonthChange5 L3StDevChanges L3NumRevisionsLog L1lnAge L1lnAvePubs if L1NumRevisions==0 & L2NumRevisions==0 & L1.TotalPubs!=0  & Tot5Month>=92 & Tot5Month<=99
predict xbChange2, xb
gen xbPredict2 = exp(xbChange2)*(L1NumRevisions+1) - 1 if L1NumRevisions==0 & L2NumRevisions==0 & L1.TotalPubs!=0



/*  1  period */

regress D1NumRevisionsLog L1NumWeeks L1NumDays L1NumDaysLastMth5 L1NumRevisions L1NumRevisionsSq L1YearUniqueArticles L1reverted L1delta L1WeekChange1 L1WeekChange2 L1WeekChange3 L1WeekChange4 L1WeekChange5 L1WeekChange6 L1WeekChange7 L1WeekChange8 L1WeekChange9 L1WeekChange10 L1WeekChange11 L1WeekChange12 L1WeekChange13 L1WeekChange14 L1WeekChange15 L1WeekChange16 L1WeekChange17 L1WeekChange18 L1WeekChange19 L1WeekChange20 L1MonthChange1 L1MonthChange2 L1MonthChange3 L1MonthChange4 L1MonthChange5 L1NumRevisionsLog L1YearUniqueArticlesPct if L1.TotalPubs!=0 & L1.New==1 & Tot5Month>=93 & Tot5Month<=99
predict xbChange3 if L1.TotalPubs!=0 & L1.New==1, xb
gen xbPredict3 = exp(xbChange3)*(L1NumRevisions+1) - 1  if L1NumRevisions!=0 & L1.TotalPubs!=0 & L1.New==1


/*  2  periods */

regress D1NumRevisionsLog L1NumWeeks L2NumWeeks L1NumDays L2NumDays L1NumDaysLastMth5 L2NumDaysLastMth5 L1NumRevisions L1NumRevisionsSq L1YearUniqueArticles L1reverted L1delta D2YearUniqueArticlesLog L1WeekChange1 L1WeekChange2 L1WeekChange3 L1WeekChange4 L1WeekChange5 L1WeekChange6 L1WeekChange7 L1WeekChange8 L1WeekChange9 L1WeekChange10 L1WeekChange11 L1WeekChange12 L1WeekChange13 L1WeekChange14 L1WeekChange15 L1WeekChange16 L1WeekChange17 L1WeekChange18 L1WeekChange19 L1WeekChange20 L2WeekChange1 L2WeekChange2 L2WeekChange3 L2WeekChange4 L2WeekChange5 L2WeekChange6 L2WeekChange7 L2WeekChange8 L2WeekChange9 L2WeekChange10 L2WeekChange11 L2WeekChange12 L2WeekChange13 L2WeekChange14 L2WeekChange15 L2WeekChange16 L2WeekChange17 L2WeekChange18 L2WeekChange19 L2WeekChange20 L1MonthChange1 L1MonthChange2 L1MonthChange3 L1MonthChange4 L1MonthChange5 L2MonthChange1 L2MonthChange2 L2MonthChange3 L2MonthChange4 L2MonthChange5 L1StDevChanges L2StDevChanges L1WeekStDevChanges L2WeekStDevChanges D2NumRevisionsLog L1NumRevisionsLog L1YearUniqueArticlesPct L2YearUniqueArticlesPct L1AvePubs if L1.TotalPubs!=0 & L1.New==0 & L2.New==1 & Tot5Month>=93 & Tot5Month<=99
predict xbChange4 if L1.TotalPubs!=0 & L1.New==0 & L2.New==1, xb
gen xbPredict4 = exp(xbChange4)*(L1NumRevisions+1) - 1  if L1NumRevisions!=0 & L1.TotalPubs!=0 & L1.New==0 & L2.New==1



/*  3 periods */

regress D1NumRevisionsLog L1NumWeeks L2NumWeeks L3NumWeeks L1NumDays L2NumDays L3NumDays L1NumDaysLastMth5 L2NumDaysLastMth5 L3NumDaysLastMth5 L1NumRevisions L1NumRevisionsSq L1YearUniqueArticles L1reverted L1delta D2YearUniqueArticlesLog L1WeekChange1 L1WeekChange2 L1WeekChange3 L1WeekChange4 L1WeekChange5 L1WeekChange6 L1WeekChange7 L1WeekChange8 L1WeekChange9 L1WeekChange10 L1WeekChange11 L1WeekChange12 L1WeekChange13 L1WeekChange14 L1WeekChange15 L1WeekChange16 L1WeekChange17 L1WeekChange18 L1WeekChange19 L1WeekChange20 L2WeekChange1 L2WeekChange2 L2WeekChange3 L2WeekChange4 L2WeekChange5 L2WeekChange6 L2WeekChange7 L2WeekChange8 L2WeekChange9 L2WeekChange10 L2WeekChange11 L2WeekChange12 L2WeekChange13 L2WeekChange14 L2WeekChange15 L2WeekChange16 L2WeekChange17 L2WeekChange18 L2WeekChange19 L2WeekChange20 L1MonthChange1 L1MonthChange2 L1MonthChange3 L1MonthChange4 L1MonthChange5 L2MonthChange1 L2MonthChange2 L2MonthChange3 L2MonthChange4 L2MonthChange5 L3MonthChange1 L3MonthChange2 L3MonthChange3 L3MonthChange4 L3MonthChange5 L1StDevChanges L2StDevChanges L3StDevChanges L1WeekStDevChanges L2WeekStDevChanges L3WeekStDevChanges D2NumRevisionsLog D3NumRevisionsLog L1NumRevisionsLog L1revertedPct L2revertedPct L1YearUniqueArticlesPct L2YearUniqueArticlesPct L3YearUniqueArticlesPct if L1.TotalPubs!=0 & L1.New==0 & L2.New==0 & L3.New==1 & Tot5Month>=93 & Tot5Month<=99
predict xbChange5 if L1.TotalPubs!=0 & L1.New==0 & L2.New==0 & L3.New==1, xb
gen xbPredict5 = exp(xbChange5)*(L1NumRevisions+1) - 1  if L1NumRevisions!=0 & L1.TotalPubs!=0 & L1.New==0 & L2.New==0 & L3.New==1


/*  4 periods */

regress D1NumRevisionsLog L1NumWeeks L2NumWeeks L3NumWeeks L4NumWeeks L1NumDays L2NumDays L3NumDays L4NumDays L1NumDaysLastMth5 L2NumDaysLastMth5 L3NumDaysLastMth5 L4NumDaysLastMth5 L1NumRevisions L1NumRevisionsSq L1YearUniqueArticles L1reverted L1delta D2YearUniqueArticlesLog L1WeekChange1 L1WeekChange2 L1WeekChange3 L1WeekChange4 L1WeekChange5 L1WeekChange6 L1WeekChange7 L1WeekChange8 L1WeekChange9 L1WeekChange10 L1WeekChange11 L1WeekChange12 L1WeekChange13 L1WeekChange14 L1WeekChange15 L1WeekChange16 L1WeekChange17 L1WeekChange18 L1WeekChange19 L1WeekChange20 L2WeekChange1 L2WeekChange2 L2WeekChange3 L2WeekChange4 L2WeekChange5 L2WeekChange6 L2WeekChange7 L2WeekChange8 L2WeekChange9 L2WeekChange10 L2WeekChange11 L2WeekChange12 L2WeekChange13 L2WeekChange14 L2WeekChange15 L2WeekChange16 L2WeekChange17 L2WeekChange18 L2WeekChange19 L2WeekChange20 L1MonthChange1 L1MonthChange2 L1MonthChange3 L1MonthChange4 L1MonthChange5 L2MonthChange1 L2MonthChange2 L2MonthChange3 L2MonthChange4 L2MonthChange5 L3MonthChange1 L3MonthChange2 L3MonthChange3 L3MonthChange4 L3MonthChange5 L4MonthChange1 L4MonthChange2 L4MonthChange3 L4MonthChange4 L4MonthChange5 L1StDevChanges L2StDevChanges L3StDevChanges L4StDevChanges L1WeekStDevChanges L2WeekStDevChanges L3WeekStDevChanges L4WeekStDevChanges D2NumRevisionsLog D3NumRevisionsLog D4NumRevisionsLog L1NumRevisionsLog L1revertedPct L2revertedPct L1YearUniqueArticlesPct L2YearUniqueArticlesPct L3YearUniqueArticlesPct L4YearUniqueArticlesPct L1AvePubs if L1.TotalPubs!=0 & L1.New==0 & L2.New==0 & L3.New==0 & L4.New==1 & Tot5Month>=93 & Tot5Month<=99
predict xbChange6 if L1.TotalPubs!=0 & L1.New==0 & L2.New==0 & L3.New==0 & L4.New==1, xb
gen xbPredict6 = exp(xbChange6)*(L1NumRevisions+1) - 1  if L1NumRevisions!=0 & L1.TotalPubs!=0 & L1.New==0 & L2.New==0 & L3.New==0 & L4.New==1


/*  5 periods */

regress D1NumRevisionsLog L1NumWeeks L2NumWeeks L3NumWeeks L4NumWeeks L5NumWeeks L1NumDays L2NumDays L3NumDays L4NumDays L5NumDays L1NumDaysLastMth5 L2NumDaysLastMth5 L3NumDaysLastMth5 L4NumDaysLastMth5 L5NumDaysLastMth5 L1NumRevisions L1NumRevisionsSq L1YearUniqueArticles L1reverted L1delta D2YearUniqueArticlesLog L1WeekChange1 L1WeekChange2 L1WeekChange3 L1WeekChange4 L1WeekChange5 L1WeekChange6 L1WeekChange7 L1WeekChange8 L1WeekChange9 L1WeekChange10 L1WeekChange11 L1WeekChange12 L1WeekChange13 L1WeekChange14 L1WeekChange15 L1WeekChange16 L1WeekChange17 L1WeekChange18 L1WeekChange19 L1WeekChange20 L2WeekChange1 L2WeekChange2 L2WeekChange3 L2WeekChange4 L2WeekChange5 L2WeekChange6 L2WeekChange7 L2WeekChange8 L2WeekChange9 L2WeekChange10 L2WeekChange11 L2WeekChange12 L2WeekChange13 L2WeekChange14 L2WeekChange15 L2WeekChange16 L2WeekChange17 L2WeekChange18 L2WeekChange19 L2WeekChange20 L1MonthChange1 L1MonthChange2 L1MonthChange3 L1MonthChange4 L1MonthChange5 L2MonthChange1 L2MonthChange2 L2MonthChange3 L2MonthChange4 L2MonthChange5 L3MonthChange1 L3MonthChange2 L3MonthChange3 L3MonthChange4 L3MonthChange5 L4MonthChange1 L4MonthChange2 L4MonthChange3 L4MonthChange4 L4MonthChange5 L5MonthChange1 L5MonthChange2 L5MonthChange3 L5MonthChange4 L5MonthChange5 L1StDevChanges L2StDevChanges L3StDevChanges L4StDevChanges L5StDevChanges L1WeekStDevChanges L2WeekStDevChanges L3WeekStDevChanges L4WeekStDevChanges L5WeekStDevChanges D2NumRevisionsLog D3NumRevisionsLog D4NumRevisionsLog D5NumRevisionsLog L1NumRevisionsLog L1revertedPct L2revertedPct L1YearUniqueArticlesPct L2YearUniqueArticlesPct L3YearUniqueArticlesPct L4YearUniqueArticlesPct if L1.TotalPubs!=0 & L1.New==0 & L2.New==0 & L3.New==0 & L4.New==0 & L5.New==1 & Tot5Month>=93 & Tot5Month<=99
predict xbChange7 if L1.TotalPubs!=0 & L1.New==0 & L2.New==0 & L3.New==0 & L4.New==0 & L5.New==1, xb
gen xbPredict7 = exp(xbChange7)*(L1NumRevisions+1) - 1  if L1NumRevisions!=0 & L1.TotalPubs!=0 & L1.New==0 & L2.New==0 & L3.New==0 & L4.New==0 & L5.New==1


/*  6 periods */


regress D1NumRevisionsLog L1NumWeeks L2NumWeeks L3NumWeeks L4NumWeeks L5NumWeeks L6NumWeeks L1NumDays L2NumDays L3NumDays L4NumDays L5NumDays L6NumDays L1NumDaysLastMth5 L2NumDaysLastMth5 L3NumDaysLastMth5 L4NumDaysLastMth5 L5NumDaysLastMth5 L6NumDaysLastMth5 L1NumRevisions L1NumRevisionsSq L1YearUniqueArticles L1reverted L1delta D2YearUniqueArticlesLog L1WeekChange1 L1WeekChange2 L1WeekChange3 L1WeekChange4 L1WeekChange5 L1WeekChange6 L1WeekChange7 L1WeekChange8 L1WeekChange9 L1WeekChange10 L1WeekChange11 L1WeekChange12 L1WeekChange13 L1WeekChange14 L1WeekChange15 L1WeekChange16 L1WeekChange17 L1WeekChange18 L1WeekChange19 L1WeekChange20 L2WeekChange1 L2WeekChange2 L2WeekChange3 L2WeekChange4 L2WeekChange5 L2WeekChange6 L2WeekChange7 L2WeekChange8 L2WeekChange9 L2WeekChange10 L2WeekChange11 L2WeekChange12 L2WeekChange13 L2WeekChange14 L2WeekChange15 L2WeekChange16 L2WeekChange17 L2WeekChange18 L2WeekChange19 L2WeekChange20 L1MonthChange1 L1MonthChange2 L1MonthChange3 L1MonthChange4 L1MonthChange5 L2MonthChange1 L2MonthChange2 L2MonthChange3 L2MonthChange4 L2MonthChange5 L3MonthChange1 L3MonthChange2 L3MonthChange3 L3MonthChange4 L3MonthChange5 L4MonthChange1 L4MonthChange2 L4MonthChange3 L4MonthChange4 L4MonthChange5 L5MonthChange1 L5MonthChange2 L5MonthChange3 L5MonthChange4 L5MonthChange5 L6MonthChange1 L6MonthChange2 L6MonthChange3 L6MonthChange4 L6MonthChange5 L1StDevChanges L2StDevChanges L3StDevChanges L4StDevChanges L5StDevChanges L6StDevChanges L1WeekStDevChanges L2WeekStDevChanges L3WeekStDevChanges L4WeekStDevChanges L5WeekStDevChanges L6WeekStDevChanges D2NumRevisionsLog D3NumRevisionsLog D4NumRevisionsLog D5NumRevisionsLog D6NumRevisionsLog D7NumRevisionsLog L1NumRevisionsLog L1revertedPct L2revertedPct L1YearUniqueArticlesPct L2YearUniqueArticlesPct L3YearUniqueArticlesPct L4YearUniqueArticlesPct L1Age L1Age2 L1AvePubs if L1.TotalPubs!=0 & L1.New==0 & L2.New==0 & L3.New==0 & L4.New==0 & L5.New==0 & Tot5Month>=93 & Tot5Month<=99
predict xbChange8 if L1.TotalPubs!=0 & L1.New==0 & L2.New==0 & L3.New==0 & L4.New==0 & L5.New==0, xb
gen xbPredict8 = exp(xbChange8)*(L1NumRevisions+1) - 1  if L1NumRevisions!=0 & L1.TotalPubs!=0 & L1.New==0 & L2.New==0 & L3.New==0 & L4.New==0 & L5.New==0




cap drop BasePredict Predict z x 
cap drop Resid L1Resid

gen BasePredict = xbPredict8*0.85 if  L1.New==0 & L2.New==0 & L3.New==0 & L4.New==0 & L5.New==0 & L1.TotalPubs!=0
replace BasePredict = xbPredict7*0.85 if L5.New==1 & L1.TotalPubs!=0
replace BasePredict = xbPredict6*0.85 if L4.New==1 & L1.TotalPubs!=0
replace BasePredict = xbPredict5*0.85 if L3.New==1 & L1.TotalPubs!=0 
replace BasePredict = xbPredict4*0.75 if L2.New==1 & L1.TotalPubs!=0
replace BasePredict = xbPredict3*0.75 if L1.New==1 & L1.TotalPubs!=0
replace BasePredict = xbPredict2*0.4 if L1NumRevisions==0 & L2NumRevisions==0 & L1.TotalPubs!=0
replace BasePredict = xbPredict1*0.5 if L1NumRevisions==0 & L2NumRevisions!=0 & L1.TotalPubs!=0
replace BasePredict = 0 if New==1

 
gen Predict = xbPredict8*0.89 - 0.05 if  L1.New==0 & L2.New==0 & L3.New==0 & L4.New==0 & L5.New==0 & L1.TotalPubs!=0
replace Predict = xbPredict7*0.85 if L5.New==1 & L1.TotalPubs!=0
replace Predict = xbPredict6*0.85 if L4.New==1 & L1.TotalPubs!=0
replace Predict = xbPredict5*0.85 if L3.New==1 & L1.TotalPubs!=0 
replace Predict = xbPredict4*0.75 if L2.New==1 & L1.TotalPubs!=0
replace Predict = xbPredict3*0.75 - 0.05 if L1.New==1 & L1.TotalPubs!=0
replace Predict = xbPredict2*0.4 if L1NumRevisions==0 & L2NumRevisions==0 & L1.TotalPubs!=0
replace Predict = xbPredict1*0.5 if L1NumRevisions==0 & L2NumRevisions!=0 & L1.TotalPubs!=0
replace Predict = 0 if New==1



gen Resid = NumRevisions - Predict
gen L1Resid = L1.Resid



gen Category = 8 if  L1.New==0 & L2.New==0 & L3.New==0 & L4.New==0 & L5.New==0 & L1.TotalPubs!=0
replace Category = 7 if L5.New==1 & L1.TotalPubs!=0
replace Category = 6 if L4.New==1 & L1.TotalPubs!=0
replace Category = 5 if L3.New==1 & L1.TotalPubs!=0 
replace Category = 4 if L2.New==1 & L1.TotalPubs!=0
replace Category = 3 if L1.New==1 & L1.TotalPubs!=0
replace Category = 2 if L1NumRevisions==0 & L2NumRevisions==0 & L1.TotalPubs!=0
replace Category = 1 if L1NumRevisions==0 & L2NumRevisions!=0 & L1.TotalPubs!=0
replace Category = 0 if New==1

tabstat Category if Tot5Month==101, statistics( count ) by(Category) columns(variables)



drop L1*

gen L1NumRevisions=L1.NumRevisions

gen z = (log(BasePredict + 1) - log(NumRevisions + 1))^2
gen x = (log(Predict + 1) - log(NumRevisions + 1))^2
tabstat z x if Tot5Month>90 & Tot5Month<101 & New!=1, statistics( count mean ) by(Tot5Month) columns(variables)



keep if Tot5Month==101
replace Predict = 0.01 if Predict<0
replace Predict = 0.2 if Predict<0.2
order user_id Predict




